#pragma once

#include <cstring>

namespace pdclib
{

    size_t strlen( const char *s )
    {
        size_t rc = 0;
        while ( s[rc] )
        {
            ++rc;
        }
        return rc;
    }

    char * strcpy( char * dst, const char * src )
    {
        char * rc = dst;
        while ( ( *dst++ = *src++ ) );
        return rc;
    }

    char * strcat( char * dst, const char * src )
    {
        char * rc = dst;
        if ( *dst )
        {
            while ( *++dst );
        }
        while ( (*dst++ = *src++) );
        return rc;
    }

    int strcmp( const char * lhs, const char * rhs )
    {
        while ( ( *lhs ) && ( *lhs == *rhs ) )
        {
            ++lhs;
            ++rhs;
        }
        return ( *(unsigned char *)lhs - *(unsigned char *)rhs );
    }

    char *strchr( const char * str, int c )
    {
        do
        {
            if ( *str == (char) c )
            {
                return (char *) str;
            }
        } while ( *str++ );
        return NULL;
    }

} // namespace musl
