#pragma once

#include <cstring>

namespace uclibc
{

    size_t strlen( const char *s )
    {
        const char * p;

        for (p=s ; *p ; p++);

        return p - s;
    }

    char * strcpy( char * dst, const char * src )
    {
        char *s = dst;
        while ( (*s++ = *src++) != 0 );
        return dst;
    }

    char * strcat( char * dst, const char * src )
    {
        char *s = dst;

        while (*s++);
        --s;
        while ((*s++ = *src++) != 0);

        return dst;
    }

    int strcmp( const char * lhs, const char * rhs )
    {
        int r;
        while (((r = ((int)(*((unsigned char *)lhs))) - *((unsigned char *)rhs++))
                == 0) && *lhs++);
        return r;
    }

    char *strchr(const char *s, int c)
    {
        do {
            if (*s == ((char)c)) {
                return (char *) s;	/* silence the warning */
            }
        } while (*s++);

        return NULL;
    }

} // namespace uclibc
